/*
 * ZeroInstance.hpp
 *
 *  Created on: Aug 10, 2012
 *      Author: heber
 */

#ifndef ZEROINSTANCE_HPP_
#define ZEROINSTANCE_HPP_


// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

/** This functions returns an instance equal to zero.
 *
 * This serves two functions: One the one hand we need a zero value to intialize
 * the (Orthogonal)Summation. On the other hand, ZeroInstance<T> also marks a
 * special (Set)Value of a subset that should not contribute, i.e. whose
 * contribution is set to zero.
 *
 * @return instance initialized to zero
 */
template <typename T> T ZeroInstance()
{
  return NULL;
}

template<> inline double ZeroInstance<double>() { return 0.; }
template<> inline int ZeroInstance<int>() { return 0; }
template<> inline size_t ZeroInstance<size_t>() { return (size_t)0; }


#endif /* ZEROINSTANCE_HPP_ */
